"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var helpers_1 = require("./helpers");
function applyEach(pipe) {
    return function (values, context) {
        helpers_1.throwContextExecutionFlow('applyEach', context, 'async');
        helpers_1.throwIfNotArray('applyEach', values);
        return values.map(function (value) { return pipe.resolve(value); });
    };
}
exports.applyEach = applyEach;
function applyEachSync(pipe) {
    return function (values, context) {
        helpers_1.throwContextExecutionFlow('applyEachSync', context, 'sync');
        helpers_1.throwIfNotArray('applyEach', values);
        return values.map(function (value) { return pipe.resolveSync(value); });
    };
}
exports.applyEachSync = applyEachSync;
function join(char) {
    return function (arr) {
        helpers_1.throwIfNotArray('applyEach', arr);
        return arr.join(char);
    };
}
exports.join = join;
function nth(index) {
    return function (arg) {
        helpers_1.throwIfNotArray('nth', arg);
        return arg[index];
    };
}
exports.nth = nth;
function reverse() {
    return function (arr) {
        helpers_1.throwIfNotArray('reverse', arr);
        var newArr = arr.slice();
        var length = newArr.length;
        for (var i = length / 2; i > 0; i--) {
            var startIndex = length - i;
            var left = newArr[startIndex];
            var right = newArr[i];
            newArr[startIndex] = right;
            newArr[i] = left;
        }
        return arr;
    };
}
exports.reverse = reverse;
