"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function getTypeOf(arg) {
    var type = Object.prototype.toString.call(arg);
    return type
        .replace('[object ', '')
        .slice(0, -1)
        .toLowerCase();
}
exports.getTypeOf = getTypeOf;
function isContextFlowAsync(arg) {
    return arg.executionFlow === 'async';
}
exports.isContextFlowAsync = isContextFlowAsync;
function isContextFlowSync(arg) {
    return arg.executionFlow === 'sync';
}
exports.isContextFlowSync = isContextFlowSync;
function isNullOrUndefined(arg) {
    return arg === undefined || arg === null;
}
exports.isNullOrUndefined = isNullOrUndefined;
function isPipe(arg) {
    if (typeof arg !== 'object') {
        return false;
    }
    if (arg === null) {
        return false;
    }
    if ('pipe' in arg) {
        return arg.type === 'pipe';
    }
    return false;
}
exports.isPipe = isPipe;
function throwContextExecutionFlow(functionName, context, flow) {
    if (context.executionFlow !== flow) {
        throw new Error("Cannot use " + functionName + " on " + context.executionFlow + " context");
    }
}
exports.throwContextExecutionFlow = throwContextExecutionFlow;
function throwIfNotArray(functionName, value) {
    if (!Array.isArray(value)) {
        throw new TypeError(functionName + " argument must be a numbers array");
    }
}
exports.throwIfNotArray = throwIfNotArray;
function throwIfNotBoolean(functionName, value) {
    if (typeof value !== 'boolean') {
        throw new TypeError(functionName + " argument must be a numbers array");
    }
}
exports.throwIfNotBoolean = throwIfNotBoolean;
function throwIfNotFunction(functionName, paramName, value) {
    if (typeof value !== 'function') {
        throw new TypeError(functionName + "'s " + paramName + " argument must be a function");
    }
}
exports.throwIfNotFunction = throwIfNotFunction;
function throwIfNotObject(functionName, value) {
    if (typeof value !== 'object') {
        throw new TypeError(functionName + " argument must be a valid object");
    }
}
exports.throwIfNotObject = throwIfNotObject;
function throwIfNotNumber(functionName, value) {
    if (typeof value !== 'number') {
        throw new TypeError(functionName + " argument must be a number");
    }
}
exports.throwIfNotNumber = throwIfNotNumber;
function throwIfNotString(functionName, value) {
    if (typeof value !== 'string') {
        throw new TypeError(functionName + " arg must be a string");
    }
}
exports.throwIfNotString = throwIfNotString;
