import { IContext } from './pipe';
export declare type Condition<Type> = (arg: Type) => boolean;
export declare type SwitchOption<TValue> = (arg: unknown) => ISwitchResult<TValue>;
export interface ISwitchResult<TValue> {
    default: boolean;
    success: boolean;
    value: TValue;
}
export declare function createSwitch<TValue>(...args: SwitchOption<TValue>[]): (arg: TValue) => unknown;
export declare function createSwitchDefault<Value>(value: Value): SwitchOption<Value>;
export declare function createSwitchOption<Match, Value>(match: Match, value: Value): SwitchOption<Value>;
export declare function fold<Left, Right>(left: Left, right: Right): <T extends boolean>(arg: T) => T extends true ? Right : Left;
export declare function ifElse<TCondition extends Condition<K>, Left, Right, K>(condition: TCondition, left: Left, right: Right): <T extends K>(arg: T, context: IContext) => ReturnType<TCondition> extends true ? Right : Left;
