import { IPipe, ExplicitCallable, IContext } from './pipe';
export declare function apply<Initial, Output>(pipe: IPipe<Initial, Output>): ExplicitCallable<Initial, Output>;
export declare function applySync<Initial, Output>(pipe: IPipe<Initial, Output>): ExplicitCallable<Initial, Output>;
/**
 * Puts a value inside a pipeline
 * @export
 * @template TValue
 * @param {TValue} value
 * @returns {() => TValue}
 */
export declare function put<TValue>(value: TValue): () => TValue;
/**
 * @export
 * @template T
 * @template TValue
 * @template TReturn
 * @param {T} callback
 * @returns {((arg: TValue) => TReturn | void)}
 */
export declare function safeCall<T extends (arg: TValue) => TReturn, TValue, TReturn>(callback: T, fallback?: TReturn): (arg: TValue) => TReturn | undefined;
export declare function useCallValue<TCallValue = unknown>(): (value: unknown, context: IContext<unknown, TCallValue>) => TCallValue;
export declare function useValue(): <TArg>(arg: TArg) => TArg;
