import { Callable } from './pipe';
export declare type TypeCheckerFunction = (value: unknown) => boolean;
export declare type KnownTypes = 'bigint' | 'boolean' | 'function' | 'undefined' | 'number' | 'object' | 'string';
export declare function exactTypeOf(typeName: string): Callable;
export declare function ofType<T extends KnownTypes>(typeName: T): Callable;
export declare function toArray(): <T>(arg: T) => T[];
export declare function toBoolean(): <T>(arg: T) => boolean;
export declare function toDate(): (arg: string | number) => Date;
export declare function toNumber(): (arg: unknown) => number;
export declare function toString(): (arg: unknown) => string;
