"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var helpers_1 = require("./helpers");
function exactTypeOf(typeName) {
    return function (arg) {
        if (helpers_1.getTypeOf(arg) === typeName) {
            return arg;
        }
        throw new TypeError("Invalid type " + helpers_1.getTypeOf(arg) + ", expected " + typeName);
    };
}
exports.exactTypeOf = exactTypeOf;
function ofType(typeName) {
    return function (arg) {
        if (typeof arg === typeName) {
            return arg;
        }
        throw new TypeError("Invalid type " + typeof arg + ", expected " + typeName);
    };
}
exports.ofType = ofType;
function toArray() {
    return function (arg) { return [arg]; };
}
exports.toArray = toArray;
function toBoolean() {
    return function (arg) { return (!arg === true ? false : true); };
}
exports.toBoolean = toBoolean;
function toDate() {
    return function (arg) { return new Date(arg); };
}
exports.toDate = toDate;
function toNumber() {
    return function (arg) { return Number(arg); };
}
exports.toNumber = toNumber;
function toString() {
    return function (arg) { return String(arg); };
}
exports.toString = toString;
